--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.2i
--  \   \         Application : ISE
--  /   /         Filename : top_tbw.vhw
-- /___/   /\     Timestamp : Tue Nov 06 09:35:07 2007
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: top_tbw
--Device: Xilinx
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY top_tbw IS
END top_tbw;

ARCHITECTURE testbench_arch OF top_tbw IS
    FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";

    COMPONENT MAIN
        PORT (
            RSTN : In std_logic;
            MCLK : In std_logic;
            RXFN : In std_logic;
            FD : In std_logic_vector (7 DownTo 0);
            RDN : Out std_logic;
            LRCK : Out std_logic;
            SCK : Out std_logic;
            SD : Out std_logic
        );
    END COMPONENT;

    SIGNAL RSTN : std_logic := '0';
    SIGNAL MCLK : std_logic := '0';
    SIGNAL RXFN : std_logic := '0';
    SIGNAL FD : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL RDN : std_logic := '0';
    SIGNAL LRCK : std_logic := '0';
    SIGNAL SCK : std_logic := '0';
    SIGNAL SD : std_logic := '0';

    constant PERIOD : time := 100 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 50 ns;

    BEGIN
        UUT : MAIN
        PORT MAP (
            RSTN => RSTN,
            MCLK => MCLK,
            RXFN => RXFN,
            FD => FD,
            RDN => RDN,
            LRCK => LRCK,
            SCK => SCK,
            SD => SD
        );

        PROCESS    -- clock process for MCLK
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                MCLK <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                MCLK <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            BEGIN
                -- -------------  Current Time:  90ns
                WAIT FOR 90 ns;
                RXFN <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  790ns
                WAIT FOR 700 ns;
                RXFN <= '0';
                -- -------------------------------------
                -- -------------  Current Time:  990ns
                WAIT FOR 200 ns;
                RSTN <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  1790ns
                WAIT FOR 800 ns;
                FD <= "00000001";
                -- -------------------------------------
                -- -------------  Current Time:  2590ns
                WAIT FOR 800 ns;
                FD <= "00000010";
                -- -------------------------------------
                -- -------------  Current Time:  3390ns
                WAIT FOR 800 ns;
                FD <= "00000011";
                -- -------------------------------------
                -- -------------  Current Time:  4190ns
                WAIT FOR 800 ns;
                FD <= "00000100";
                -- -------------------------------------
                -- -------------  Current Time:  4990ns
                WAIT FOR 800 ns;
                FD <= "00000101";
                -- -------------------------------------
                -- -------------  Current Time:  5790ns
                WAIT FOR 800 ns;
                FD <= "00000110";
                -- -------------------------------------
                -- -------------  Current Time:  6590ns
                WAIT FOR 800 ns;
                FD <= "00000111";
                -- -------------------------------------
                -- -------------  Current Time:  7390ns
                WAIT FOR 800 ns;
                FD <= "00001000";
                -- -------------------------------------
                -- -------------  Current Time:  8190ns
                WAIT FOR 800 ns;
                FD <= "00001001";
                -- -------------------------------------
                -- -------------  Current Time:  8990ns
                WAIT FOR 800 ns;
                FD <= "00001010";
                -- -------------------------------------
                -- -------------  Current Time:  9790ns
                WAIT FOR 800 ns;
                FD <= "00001011";
                -- -------------------------------------
                -- -------------  Current Time:  10590ns
                WAIT FOR 800 ns;
                FD <= "00001100";
                -- -------------------------------------
                -- -------------  Current Time:  11390ns
                WAIT FOR 800 ns;
                FD <= "00001101";
                -- -------------------------------------
                -- -------------  Current Time:  12190ns
                WAIT FOR 800 ns;
                FD <= "00001110";
                -- -------------------------------------
                -- -------------  Current Time:  12990ns
                WAIT FOR 800 ns;
                FD <= "00001111";
                -- -------------------------------------
                -- -------------  Current Time:  13790ns
                WAIT FOR 800 ns;
                FD <= "00010000";
                -- -------------------------------------
                -- -------------  Current Time:  14590ns
                WAIT FOR 800 ns;
                FD <= "00010001";
                -- -------------------------------------
                -- -------------  Current Time:  15390ns
                WAIT FOR 800 ns;
                FD <= "00010010";
                -- -------------------------------------
                -- -------------  Current Time:  16190ns
                WAIT FOR 800 ns;
                FD <= "00010011";
                -- -------------------------------------
                -- -------------  Current Time:  16990ns
                WAIT FOR 800 ns;
                FD <= "00010100";
                -- -------------------------------------
                -- -------------  Current Time:  17790ns
                WAIT FOR 800 ns;
                FD <= "00010101";
                -- -------------------------------------
                -- -------------  Current Time:  18590ns
                WAIT FOR 800 ns;
                FD <= "00010110";
                -- -------------------------------------
                -- -------------  Current Time:  19390ns
                WAIT FOR 800 ns;
                FD <= "00010111";
                -- -------------------------------------
                -- -------------  Current Time:  20190ns
                WAIT FOR 800 ns;
                FD <= "00011000";
                -- -------------------------------------
                -- -------------  Current Time:  20990ns
                WAIT FOR 800 ns;
                FD <= "00011001";
                -- -------------------------------------
                -- -------------  Current Time:  21790ns
                WAIT FOR 800 ns;
                FD <= "00011010";
                -- -------------------------------------
                -- -------------  Current Time:  22590ns
                WAIT FOR 800 ns;
                FD <= "00011011";
                -- -------------------------------------
                -- -------------  Current Time:  23390ns
                WAIT FOR 800 ns;
                FD <= "00011100";
                -- -------------------------------------
                -- -------------  Current Time:  24190ns
                WAIT FOR 800 ns;
                FD <= "00011101";
                -- -------------------------------------
                -- -------------  Current Time:  24990ns
                WAIT FOR 800 ns;
                FD <= "00011110";
                -- -------------------------------------
                -- -------------  Current Time:  25790ns
                WAIT FOR 800 ns;
                FD <= "00011111";
                -- -------------------------------------
                -- -------------  Current Time:  26490ns
                WAIT FOR 700 ns;
                FD <= "10101111";
                -- -------------------------------------
                -- -------------  Current Time:  26590ns
                WAIT FOR 100 ns;
                FD <= "00100000";
                -- -------------------------------------
                -- -------------  Current Time:  27390ns
                WAIT FOR 800 ns;
                FD <= "00100001";
                -- -------------------------------------
                -- -------------  Current Time:  28190ns
                WAIT FOR 800 ns;
                FD <= "00100010";
                -- -------------------------------------
                -- -------------  Current Time:  28990ns
                WAIT FOR 800 ns;
                FD <= "00100011";
                -- -------------------------------------
                -- -------------  Current Time:  29790ns
                WAIT FOR 800 ns;
                FD <= "00100100";
                -- -------------------------------------
                -- -------------  Current Time:  30590ns
                WAIT FOR 800 ns;
                FD <= "00100101";
                -- -------------------------------------
                -- -------------  Current Time:  31390ns
                WAIT FOR 800 ns;
                FD <= "00100110";
                -- -------------------------------------
                -- -------------  Current Time:  32190ns
                WAIT FOR 800 ns;
                FD <= "00100111";
                -- -------------------------------------
                -- -------------  Current Time:  32990ns
                WAIT FOR 800 ns;
                FD <= "00101000";
                -- -------------------------------------
                -- -------------  Current Time:  33790ns
                WAIT FOR 800 ns;
                FD <= "00101001";
                -- -------------------------------------
                -- -------------  Current Time:  34590ns
                WAIT FOR 800 ns;
                FD <= "00101010";
                -- -------------------------------------
                -- -------------  Current Time:  35390ns
                WAIT FOR 800 ns;
                FD <= "00101011";
                -- -------------------------------------
                -- -------------  Current Time:  36190ns
                WAIT FOR 800 ns;
                FD <= "00101100";
                -- -------------------------------------
                -- -------------  Current Time:  36990ns
                WAIT FOR 800 ns;
                FD <= "00101101";
                -- -------------------------------------
                -- -------------  Current Time:  37790ns
                WAIT FOR 800 ns;
                FD <= "00101110";
                -- -------------------------------------
                -- -------------  Current Time:  38590ns
                WAIT FOR 800 ns;
                FD <= "00101111";
                -- -------------------------------------
                -- -------------  Current Time:  39390ns
                WAIT FOR 800 ns;
                FD <= "00110000";
                -- -------------------------------------
                -- -------------  Current Time:  40190ns
                WAIT FOR 800 ns;
                FD <= "00110001";
                -- -------------------------------------
                -- -------------  Current Time:  40990ns
                WAIT FOR 800 ns;
                FD <= "00110010";
                -- -------------------------------------
                -- -------------  Current Time:  41790ns
                WAIT FOR 800 ns;
                FD <= "00110011";
                -- -------------------------------------
                -- -------------  Current Time:  42590ns
                WAIT FOR 800 ns;
                FD <= "00110100";
                -- -------------------------------------
                -- -------------  Current Time:  43390ns
                WAIT FOR 800 ns;
                FD <= "00110101";
                -- -------------------------------------
                -- -------------  Current Time:  44190ns
                WAIT FOR 800 ns;
                FD <= "00110110";
                -- -------------------------------------
                -- -------------  Current Time:  44990ns
                WAIT FOR 800 ns;
                FD <= "00110111";
                -- -------------------------------------
                -- -------------  Current Time:  45790ns
                WAIT FOR 800 ns;
                FD <= "00111000";
                -- -------------------------------------
                -- -------------  Current Time:  46590ns
                WAIT FOR 800 ns;
                FD <= "00111001";
                -- -------------------------------------
                -- -------------  Current Time:  47390ns
                WAIT FOR 800 ns;
                FD <= "00111010";
                -- -------------------------------------
                -- -------------  Current Time:  48190ns
                WAIT FOR 800 ns;
                FD <= "00111011";
                -- -------------------------------------
                -- -------------  Current Time:  48990ns
                WAIT FOR 800 ns;
                FD <= "00111100";
                -- -------------------------------------
                -- -------------  Current Time:  49790ns
                WAIT FOR 800 ns;
                FD <= "00111101";
                -- -------------------------------------
                -- -------------  Current Time:  50590ns
                WAIT FOR 800 ns;
                FD <= "00111110";
                -- -------------------------------------
                -- -------------  Current Time:  51390ns
                WAIT FOR 800 ns;
                FD <= "00111111";
                -- -------------------------------------
                -- -------------  Current Time:  52190ns
                WAIT FOR 800 ns;
                FD <= "01000000";
                -- -------------------------------------
                -- -------------  Current Time:  52990ns
                WAIT FOR 800 ns;
                FD <= "01000001";
                -- -------------------------------------
                -- -------------  Current Time:  53790ns
                WAIT FOR 800 ns;
                FD <= "01000010";
                -- -------------------------------------
                -- -------------  Current Time:  54590ns
                WAIT FOR 800 ns;
                FD <= "01000011";
                -- -------------------------------------
                -- -------------  Current Time:  55390ns
                WAIT FOR 800 ns;
                FD <= "01000100";
                -- -------------------------------------
                -- -------------  Current Time:  56190ns
                WAIT FOR 800 ns;
                FD <= "01000101";
                -- -------------------------------------
                -- -------------  Current Time:  56990ns
                WAIT FOR 800 ns;
                FD <= "01000110";
                -- -------------------------------------
                -- -------------  Current Time:  57790ns
                WAIT FOR 800 ns;
                FD <= "01000111";
                -- -------------------------------------
                -- -------------  Current Time:  58590ns
                WAIT FOR 800 ns;
                FD <= "01001000";
                -- -------------------------------------
                -- -------------  Current Time:  59390ns
                WAIT FOR 800 ns;
                FD <= "01001001";
                -- -------------------------------------
                WAIT FOR 710 ns;

            END PROCESS;

    END testbench_arch;

